
import numpy

Sbox1 = numpy.mat([["101","010","001","110","011","100","111","000"],["001","100","110","010","000","111","101","011"]])
Sbox2 = numpy.mat([["100","000","110","101","111","001","011","010"],["101","011","000","111","110","010","001","100"]])
S1={"0110" : "111", "1110" : "101", "0000" : "101", "1001" : "100", "1100" : "000", "0010" : "001", "0111" : "000", "1111" : "011", "1010" : "110", "0100" : "011", "0101" : "100", "1101" : "111", "0001" : "010", "1000" : "001", "1011" : "010", "0011" : "110"}
S2={"0110" : "011", "1110" : "001", "0000" : "100", "1001" : "011", "1100" : "110", "0010" : "110", "0111" : "010", "1111" : "100", "1010" : "000", "0100" : "111", "0101" : "001", "1101" : "010", "0001" : "000", "1000" : "101", "1011" : "111", "0011" : "101"}

def EightBitsKey (key, i):
    iBit = (i - 1) % 9 + 1
    a = key + key
    #print a[iBit:iBit+8]
    return a[iBit:iBit+8]
    #return(substring(a, xrange(iBit,iBit + 7)))

def Ln(thisString):
    return thisString[0:6]

def Rn(thisString):
    return thisString[6:12]

def Expander(Right):
    R12=Right[0:1+1]
    R56=Right[4:5+1]
    R43 = Right[3:2-1:-1]
    return R12+R43+R43+R56

def XOR(x,y):
    if(x==y):
        return "0"
    else:
        return "1"

def XORnbits(R,key,n):
    buffer = ""
    for i in xrange(0,n):
        buffer += XOR(R[i],key[i])
    return buffer
    #cat(seq(XOR(substring(R,i), substring(key,i)),i=1..n)):


def BDESoneRound (message, key, numround):
    ikey = EightBitsKey(key, numround)
    L0 = Ln(message)
    R0 = Rn(message)
    expandedR = Expander(R0)
    Sboxinput = XORnbits(expandedR, ikey, 8)
    Sboxesoutput = S1[Sboxinput[:4]] + S2[Sboxinput[4:]]
    return(R0 + XORnbits(Sboxesoutput, L0, 6))


def BDES (message, key, Rounds):
    temp = message
    for i in range(1, Rounds + 1):
        temp = BDESoneRound(temp, key, i)
        cgret = temp
    return(cgret)

def DoubleBDES (message,key1,key2,rounds):
    i=0
    temp = message
    while True:
        for j in range(1, 4):
            temp = BDESoneRound(temp, key1, j)
        for j in range(1, 4):
            temp = BDESoneRound(temp, key2, j)
        if temp == message:
            print(temp)
            return(i)
        i+=1
    return(temp)


def BDESdecr (message, key, Rounds):
    L = Ln(message)
    R = Rn(message)
    temp = R + L
    for i in range(0, Rounds - 1 + 1):
        temp = BDESoneRound(temp, key, Rounds - i)
    L = Ln(temp)
    R = Rn(temp)
    temp = R + L
    return(temp)


︡bd4d01df-d5e2-4ae9-a2d7-dad1165defd5︡
︠18447d55-aa48-4c66-bbec-137468c2b5b1︠
key="110110010"
message="101010110101"
BDESoneRound(message,key,4)
︡ffe0448c-84e0-4aad-a24a-7e5d6bfd8159︡{"stdout":"10010110\n'110101101110'\n"}︡
︠9e21b8c2-7d50-4609-b75f-753d00782e2e︠
key = "010011001"
EightBitsKey(key,2)
︡6e89f922-8f1d-4b51-a2cf-4028dbb7ab3c︡{"stdout":"00110010\n'00110010'\n"}︡
︠b8e90ef1-dd33-47a5-a365-b89cb5f043d8︠

key="110110010"
message="101010110101"
L0 = Ln(message)
R0 = Rn(message)
ER0 = Expander(R0)
k1= EightBitsKey(key,0)
SboxInputs=XORnbits(ER0,k1,8)
L0
R0
ER0
k1
SboxInputs
︡dfc593a8-bbe3-4c12-98cb-c4c9b3bd9f79︡{"stdout":"11011001\n"}︡{"stdout":"'101010'\n"}︡{"stdout":"'110101'\n"}︡{"stdout":"'11101001'\n"}︡{"stdout":"'11011001'\n"}︡{"stdout":"'00110000'\n"}︡
︠2eaff204-fab1-40c5-a5ba-c9d43a0ad587︠

test ={"0110" : "111", "1110" : "101", "0000" : "101", "1001" : "100", "1100" : "000", "0010" : "001", "0111" : "000", "1111" : "011", "1010" : "110", "0100" : "011", "0101" : "100", "1101" : "111", "0001" : "010", "1000" : "001", "1011" : "010", "0011" : "110"}
︡75d2129f-0a1d-4f5e-869f-e35247f37c89︡
︠fa805153-9624-424e-a304-4e94053332cf︠
test['0110']
︡0e2c4ce7-aed8-4468-bd79-1623bb935f13︡{"stdout":"'111'\n"}︡
︠f99f065c-7556-4261-9985-4ad8a725a42f︠

key="110011101"
message="101010110101"
Encr=BDES(message,key,6)
out = BDESdecr(Encr,key,6)
out==message
out
︡063dc6fd-839e-4e30-9b63-94d487b46d98︡{"stdout":"True\n"}︡
︠af943e61-747c-478c-8a5f-9616ffc31bb3︠

︠6f48f8f1-59f6-4509-a878-1bd5f63326ad︠

k1="000000000"
k2="111111111"
DoubleBDES("110101010010",k1,k2,512)
︡6bec4eff-0335-4185-8c0d-ad9d05ab3e60︡{"stdout":"110101010010\n66\n"}︡
︠9d7b6292-0b8c-4bf2-9061-6b83528f2481︠
numcorrect=0
numwrong=0
for i in xrange(0,(2^9)):
    #key="110011101"    
    key =format(i, '#011b')
    message="101010110101"
    Encr=BDES(message,key,6)
    out = BDESdecr(Encr,key,6)
    if out!=message:
        print key
        numwrong+=1
    else:
        numcorrect+=1
numcorrect
numwrong
︡








